.686p
.model	flat, stdcall
option	casemap :none   ; case sensitive
.nolist
include windows.inc

literal MACRO quoted_text:VARARG
LOCAL local_text
.data
  local_text db quoted_text,0
.code
EXITM <local_text>
ENDM

SADD MACRO quoted_text:VARARG
EXITM <ADDR literal(quoted_text)>
ENDM
sadd equ SADD

Text Macro TextName:Req,TextVal:Req
.data
TextName db TextVal,0
.code
endm

msg Macro qtext:VARARG
pusha
invoke MessageBox,0,addr literal(qtext),addr ProgName,0
popa
endm

GetHandle Macro MyId:Req,MyHandle:Req 
    invoke GetDlgItem,hWin,MyId
    mov MyHandle,eax         ; save handle to control
endm

uselib	MACRO	libname
	include		libname.inc
	includelib	libname.lib
ENDM

uselib user32
uselib kernel32
uselib comctl32
.listall

TimesToLoop	equ 10000000	; number of times to loop

DlgProc		PROTO :DWORD,:DWORD,:DWORD,:DWORD

.data
ProgName		db 'Timing Test',0

StartingCycle 	dd 0
CyclePart2		dd 0

CallTable	dd Doit1, Doit2, Doit3, Doit4, Doit5, Doit6, Doit7
DescTable	dd Desc1, Desc2, Desc3, Desc4, Desc5, Desc6, Desc7
DescEnd		equ $

.data?
hWin        dd ?  ; dialog handle
hInstance	dd ?
CurProcess	dd ?
Result		dd ?
Average		dd ?
TestNum 	dd ?
htemp		dd ?
buff db 100 dup (?)

;scratch for tests
Temp1		dd ?
Temp2		dd ?
.code
start:
	invoke	GetModuleHandle, NULL
	mov	hInstance, eax
	invoke	InitCommonControls
	invoke	DialogBoxParam, hInstance, 101, 0, ADDR DlgProc, 0
	invoke	ExitProcess, eax

DlgProc	proc uses ebx, hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
	.if	uMsg == WM_COMMAND
		.if	wParam > 2000 && wParam < 2999 ; one of the test buttons
			pusha
			mov eax,wParam
			sub eax,2000
			mov TestNum,eax
			invoke GetCurrentProcess
			mov [CurProcess],eax
			invoke SetPriorityClass,CurProcess,REALTIME_PRIORITY_CLASS
			mov eax,TestNum
			sub eax,1
			mov eax,[CallTable+eax*4]
			cmp eax,offset DescTable
			jae @f		; no doit set in call table
			call eax  	; call Doit1 or Doit2 or .... DoitN
@@:
			invoke SetPriorityClass,CurProcess,NORMAL_PRIORITY_CLASS
			popa
		.endif
    .elseif uMsg== WM_INITDIALOG
        mov eax,hWnd    ; save handle for everyone
        mov hWin,eax

		pusha				; set all the descriptions in the edit controls
		mov ebx,3001		; start with first description
		mov esi,offset DescTable
Dloop:
		GetHandle ebx,htemp
		invoke SendMessage,htemp,WM_SETTEXT,0,[esi]
		inc ebx
		add esi,4
		cmp esi,DescEnd
		jb Dloop
		popa
	.elseif	uMsg == WM_CLOSE
		invoke	EndDialog,hWin,0
	.endif

	xor	eax,eax
	ret
DlgProc	endp

Startup proc
	pusha		; save users setup if any
	mov eax,TestNum
	add eax,3000
	GetHandle eax,htemp
	popa
	xor eax,eax	; setup to call the EAX=0 version of CPUID to clear pipeline
	ret
Startup EndP

WrapUp proc
	sub eax,[StartingCycle]	; get result in EDX:EAX
	sbb edx,[StartingCycle+4]
	mov Result,eax
	mov ecx,TimesToLoop		; divide by number of times through the loop
	div ecx				; result of division in EAX, remainder in EDX
	mov Average,eax
	invoke wsprintf,addr buff,sadd("%i"),Result
	mov eax,TestNum
	add eax,4000
	GetHandle eax,htemp
	invoke SendMessage,htemp,WM_SETTEXT,0,addr buff
	invoke wsprintf,addr buff,sadd("%i"),Average
	mov eax,TestNum
	add eax,5000
	GetHandle eax,htemp
	invoke SendMessage,htemp,WM_SETTEXT,0,addr buff
	ret
WrapUp EndP

; --------------------  Timing Tests ----------------------------------------------------

; This is the proc to copy to create new timing tests.  Change the X in DoitX and DescX to a number and add
;   them to the CallTable and DescTable.
 
DoitX Proc
	Text DescX,'description of this test'
	; ----- place any setup desired here.  registers will not be prserved past the cpuid/rdtsc call. ----
	call Startup
	cpuid 		; call the EAX=0 version of CPUID to clear pipeline (serialize) (finish any pending instructions)
	align 16	; just to be sure all code starts with equal advantage
	rdtsc
	mov	[StartingCycle],eax
	mov	[StartingCycle+4],edx
	mov	ecx,TimesToLoop

TLoop:
	push ecx	; test code follows here ----------------------------------

	pop ecx		; end of test code ----------------------------------------
	dec ecx
	jnz	TLoop

	rdtsc
	call WrapUp
	ret
DoitX endp

;-------------------------------------- Test Procs --------------------------------
Doit1 Proc
local xx:dword
	Text Desc1,'test using a local (stack) variable and inc/dec instructions'
	call Startup
	cpuid ; call the EAX=0 version of CPUID to clear pipeline (serialize) (finish any pending instructions)
	align 16	; just to be sure all code starts with equal advantage
	rdtsc
	mov	[StartingCycle],eax
	mov	[StartingCycle+4],edx
	mov	ecx,TimesToLoop

TLoop:
	push ecx	; test code follows here ----------------------------------
	inc xx
	dec xx
	pop ecx		; end of test code ----------------------------------------
	dec ecx
	jnz	TLoop

	rdtsc
	call WrapUp
	ret
Doit1 endp

Doit2 Proc
local xx:dword
	Text Desc2,'local variable with add/sub instructions'
	call Startup
	cpuid 
	align 16	; just to be sure all code starts with equal advantage
	rdtsc
	mov	[StartingCycle],eax
	mov	[StartingCycle+4],edx
	mov	ecx,TimesToLoop

TLoop:
	push ecx	; test code follows here ----------------------------------
	add xx,1
	sub xx,1
	pop ecx		; end of test code ----------------------------------------
	dec ecx
	jnz	TLoop

	rdtsc
	call WrapUp
	ret

Doit2 endp
Doit3 Proc
	Text Desc3,'test using variable defined in .data section and inc/dec instructions'
	call Startup
	cpuid 
	align 16	; just to be sure all code starts with equal advantage
	rdtsc
	mov	[StartingCycle],eax
	mov	[StartingCycle+4],edx
	mov	ecx,TimesToLoop

TLoop:
	push ecx	; test code follows here ----------------------------------
	inc Temp1
	dec Temp1
	pop ecx		; end of test code ----------------------------------------
	dec ecx
	jnz	TLoop

	rdtsc
	call WrapUp
	ret

Doit3 endp

Doit4 Proc
	Text Desc4,'.data variable and add/sub instructions'
	Call Startup
	cpuid 
	align 16	; just to be sure all code starts with equal advantage
	rdtsc
	mov	[StartingCycle],eax
	mov	[StartingCycle+4],edx
	mov	ecx,TimesToLoop

TLoop:
	push ecx	; test code follows here ----------------------------------
	add Temp1,1
	sub Temp1,1
	pop ecx		; end of test code ----------------------------------------
	dec ecx
	jnz	TLoop

	rdtsc
	call WrapUp
	ret

Doit4 endp

Doit5 Proc
	Text Desc5,'empty loop test (using push/pop/inc ecx)'
	call Startup
	cpuid ; call the EAX=0 version of CPUID to clear pipeline (serialize) (finish any pending instructions)
	align 16	; just to be sure all code starts with equal advantage
	rdtsc
	mov	[StartingCycle],eax
	mov	[StartingCycle+4],edx
	mov	ecx,TimesToLoop

TLoop:
	push ecx	; test code follows here ----------------------------------

	pop ecx		; end of test code ----------------------------------------
	dec ecx
	jnz	TLoop

	rdtsc
	call WrapUp
	ret
Doit5 endp
Doit6 Proc
	Text Desc6,'empty loop using .data memory variable rather than push/pop inc register'
	mov	ecx,TimesToLoop
	mov Temp1,ecx
	call Startup
	cpuid ; call the EAX=0 version of CPUID to clear pipeline (serialize) (finish any pending instructions)
	align 16	; just to be sure all code starts with equal advantage
	rdtsc
	mov	[StartingCycle],eax
	mov	[StartingCycle+4],edx
	
TLoop:
					; empty loop
	dec Temp1		; end of test code ----------------------------------------
	jnz	TLoop

	rdtsc
	call WrapUp
	ret
Doit6 endp

Doit7 Proc
local xx:dword
	Text Desc7,'empty loop using local memory variable rather than push/pop inc register'
	mov	ecx,TimesToLoop
	mov xx,ecx
	call Startup
	cpuid ; call the EAX=0 version of CPUID to clear pipeline (serialize) (finish any pending instructions)
	align 16
	rdtsc
	mov	[StartingCycle],eax
	mov	[StartingCycle+4],edx
	
TLoop:
			; empty loop
	dec xx	; end of test code --------------------
	jnz	TLoop

	rdtsc
	call WrapUp
	ret
Doit7 endp


;  look into using floating point as shown below in code from Raymond
Raymond proc
.data

freq label qword
freqL   dd  ?
freqH   dd  ?

result  dt  ?    ;extended double-precision

buffer  db 32 dup(?)  ;for string output

.code

	CPUID
	RDTSC
	push edx
	push eax
	invoke Sleep,1000
	CPUID
	RDTSC
	pop ecx
	sub eax,ecx
	pop ecx
	sbb edx,ecx
	mov freqL,eax
	mov freqH,edx
	
	;...
	StartingCycler:
	CPUID
	RDTSC
	push edx
	push eax
	;jmp rerun
	
	;rerun:
	;invoke DefWindowProc,hWnd,uMsg,wParam,lParam
	
	stopp_timer:
	CPUID
	RDTSC
	pop ecx
	sub eax,ecx
	pop ecx
	sbb edx,ecx
	push edx    ;store on stack, H.O. 1st
	push eax    ;  L.O. 2nd
	finit
	fild qword ptr[esp] ;load qword from stack
	fild freq      ;loads the frequency (qword)
	fdiv
	add esp,8   ;restore stack
;	invoke FpuFLtoA,0,6,ADDR buffer,SRC1_FPU or SRC2_DIMM
	fstp  result 
	ret
Raymond EndP


end start
